package com.caimei.module.product.dao;

import com.caimei.module.product.entity.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2020/3/25
 */
@Mapper
public interface ProductModuleDao {
    List<ProductVo> getProductsByTinyType(@Param("tinyTypeID") Integer tinyTypeID, @Param("sortType") Integer sortType);

    List<SearchHistoryVo> getSearchHistoryList(Integer userId);

    Long getSearchHistoryIdByWord(String searchWord);

    void updateSearchHistoryById(SearchHistoryVo historyRecord);

    void insertSearchHistory(SearchHistoryVo historyRecord);

    void deleteSearchHistoryByUserId(Integer userId);

    List<ProductVo> searchProduct(String searchWord);

    ProductVo findProductById(Integer productID);

    List<ProductImageVo> findProductImage(Integer productID);

    ShopVo findProductShopById(Integer shopID);

    ProductDetailVo findProductDetailById(Integer productID);

    List<BigtypeVo> getBigType();

    List<SmalltypeVo> getSmallType(Integer bigTypeID);

    List<TinytypeVo> getTinytype(Integer smallTypeID);

    LadderPriceVo findLowerLadderPrice(Integer productID);

    List<LadderPriceVo> findLadderPrice(Integer productID);

    List<ProductVo> getProductsByPreferredFlag(Integer preferredFlag);

    List<Integer> getRecommendIds(Integer productID);

    List<ProductVo> getRecommendByIds(@Param("productIDs") List<Integer> productIDs);

    List<ProductVo> getDeFaultRecommend(Integer tinyTypeID);

    void deleteAllSearchHistory(Integer userId);
}
